<template>
  <div class="telemetry">
    <v-navigation-drawer app width="300">
      <div class="sideBarContent">
        <v-list-item>
          <v-list-item-content>
            <v-list-item-title class="title"> Telemetry </v-list-item-title>
            <v-list-item-subtitle> Monitor active flights </v-list-item-subtitle>
          </v-list-item-content>
        </v-list-item>
        <v-divider></v-divider>
        <li><v-btn depressed :height="20" @click="loadRouteList">Route list</v-btn></li>
        <v-divider></v-divider>

        <route-list-app-bar
        v-if="show_route_list"
        :route_data_list="route_list"
        @route-clicked="loadRouteAtIndex" />

        <telem-info-app-bar
        v-else
          :time_since_last_packet="time_since_last_packet"
          :telemetry="telemetry" />
      </div>
      <v-divider></v-divider>
      <div>
        <v-switch
          label="Drone stream"
          @change="updateStream"
        ></v-switch>
        <v-img
        lazy-src="https://picsum.photos/id/11/10/6"
        :src="drone_stream_img"
        width="100%"
        height="200"
        />
      </div>
    </v-navigation-drawer>

    <div id="telemetryMapDiv">Map will appear here soon</div>

    <v-row> </v-row>
  </div>
</template>

<script lang="ts">
import "leaflet/dist/leaflet.css";
import L from "leaflet";
import "leaflet-rotatedmarker";
import { Component, Vue } from "vue-property-decorator";
import { GavronTelem } from "@/telemetry_definitions/generated/GavronTelem";
import common_map_constructor from "@/components/CommonMapConstructor";
import { common } from "protobufjs";
import TelemInfo from "@/components/TelemInfo";
import TelemInfoAppBar from "@/components/TelemInfoAppBar.vue";
import RouteListAppBar from "@/components/RouteListAppBar.vue";
import { DroneMarker, DropMarker, DroneDropMarker } from "@/components/MapMarkers";
import RouteData, {
  loadRoutesFromServer
  } from "@/components/RoutesManagement";

const EMPTY_STREAM_IMG = 'https://conbio.org/images/content_conferences/IMCC3_Please_Stand_By.jpg';
const NR_OF_PREVIOUS_DRONE_POSITIONS = 10;
const NR_OF_PACKETS_BETWEEN_DRONE_MARKER = 10;
const BASE_DRONE_STREAM_IMG = "http://vps-e584bd76.vps.ovh.net:8080/getLastImage?flight_id=test";

@Component({
  components: {
    TelemInfoAppBar,
    RouteListAppBar
  },
})
export default class Telemetry extends Vue {
  map!: L.Map;

  map_center!: L.LatLng;

  map_zoom = 13;

  connection!: WebSocket;

  curr_drone_index = 0;

  prev_drone_markers = [] as DroneMarker[];

  cargo_drop_marker!: DropMarker;

  payload_drop_drone_marker!: DroneDropMarker;

  target_circle!: L.Circle;

  route_path_line!: L.Polyline;

  time_since_last_packet_interval!: number;

  time_since_last_packet = 0;

  last_packet_time = Date.now();

  total_packets_recieved = 0;

  telemetry = new TelemInfo();

  sae_drop_data!: GavronTelem.SaeDropDataMessage;

  route_list = [] as RouteData[];

  node_positions = [] as L.LatLng[];

  drone_stream_img = EMPTY_STREAM_IMG;

  img_index = 1;

  show_route_list = false;

  show_popups = true;

  following = true;

  previous_dropped_state = false;

  show_stream = false;

  mounted() {
    this.setupLeaflet();

    console.log("Telem Mounted");

    this.connection = new WebSocket("ws://vps-e584bd76.vps.ovh.net:4001");
    this.connection.binaryType = "arraybuffer";
    console.log(process.env.VUE_APP_API_URL);

    this.time_since_last_packet_interval = setInterval(() => this.updateTimeSinceLastPacket(), 100);

    this.connection.onmessage = (event) => {
      if (this.show_stream) {
        this.drone_stream_img = `${BASE_DRONE_STREAM_IMG}#${this.img_index}`;
        this.img_index += 1;
      }
      this.extractPacketData(event);
      this.updateSae();
      this.updateDrone();
      if (this.following) {
        this.map.setView(this.getDroneLatLng(), this.map.getZoom());
      }
    };
  }

  destroyed() {
    clearInterval(this.time_since_last_packet_interval);
    this.connection.close();
  }

  setupLeaflet() {
    console.log("Setting up leaflet");

    this.map = common_map_constructor("telemetryMapDiv");

    this.map.on("click", (e: L.LeafletMouseEvent) => {
      this.following = false;
    });

    let i;
    for (i = 0; i < NR_OF_PREVIOUS_DRONE_POSITIONS; i += 1) {
      const drone = new DroneMarker(new L.LatLng(51.505, -0.09));
      this.prev_drone_markers.push(drone);
      drone.addTo(this.map);
    }

    this.target_circle = new L.Circle([0, 0], {
      radius: 15,
      color: "blue",
      fillOpacity: 0.3,
    });
    this.target_circle.addTo(this.map);

    this.cargo_drop_marker = new DropMarker(new L.LatLng(51.505, -0.09));
    this.cargo_drop_marker.addTo(this.map);

    this.payload_drop_drone_marker = new DroneDropMarker(new L.LatLng(51.505, -0.09));
    this.payload_drop_drone_marker.addTo(this.map);
    this.payload_drop_drone_marker.setOpacity(0);

    this.route_path_line = new L.Polyline([], { color: 'gray' });
    this.route_path_line.addTo(this.map);
  }

  extractPacketData(event: any) {
    const data_bytes = new Uint8Array(event.data);
    const message = GavronTelem.GavronTelemFrame.decode(data_bytes);

    const curr_time = Date.now();

    // @ts-ignore
    this.telemetry.drone_pos = message.header?.position;
    // @ts-ignore
    this.telemetry.drone_id = message.header?.machineId;
    // @ts-ignore
    this.telemetry.flight_id = message.header?.flightId;
    // @ts-ignore
    this.time_since_last_packet = curr_time - this.last_packet_time;
    // @ts-ignore
    this.last_packet_time = curr_time;
    // @ts-ignore
    this.sae_drop_data = message.saeDropDataMessage;

    this.total_packets_recieved += 1;
    console.log(message);
  }

  updateDrone() {
    if (this.total_packets_recieved % NR_OF_PACKETS_BETWEEN_DRONE_MARKER === 0) {
      this.curr_drone_index = this.getNextIndex(this.curr_drone_index);

      let opacity = 0;
      const opacity_increase = 0.5 / NR_OF_PREVIOUS_DRONE_POSITIONS;
      let i;
      for (
        i = this.getNextIndex(this.curr_drone_index);
        i !== this.curr_drone_index;
        i = this.getNextIndex(i)
      ) {
        this.prev_drone_markers[i].setOpacity(opacity);
        opacity += opacity_increase;
      }
    }

    this.prev_drone_markers[this.curr_drone_index].setLatLng(
      this.getDroneLatLng()
    );
    this.prev_drone_markers[this.curr_drone_index].setOpacity(1);
    // @ts-ignore
    this.prev_drone_markers[this.curr_drone_index].setRotationAngle(
      this.telemetry.drone_pos.heading
    );
  }

  getNextIndex(ind: number): number {
    return (ind + 1) % NR_OF_PREVIOUS_DRONE_POSITIONS;
  }

  updateSae() {
    // Don't update SAE-related data if the machine
    // is not sending them
    if (this.sae_drop_data === null) {
      return;
    }
    if (this.targetUpdated()) {
      this.target_circle.setLatLng([
        this.sae_drop_data.targetLat,
        this.sae_drop_data.targetLng,
      ]);
    }

    if (!this.sae_drop_data.cargoDropped) {
      if (this.sae_drop_data.cargoDropped !== this.previous_dropped_state) {
        this.cargo_drop_marker.setIcon(DropMarker.predicted_drop_icon);
        this.payload_drop_drone_marker.setOpacity(0);
      }

      this.cargo_drop_marker.setLatLng([
        this.sae_drop_data.predictedDropLat,
        this.sae_drop_data.predictedDropLng,
      ]);
    }
    if (
      this.sae_drop_data.cargoDropped
      && this.sae_drop_data.cargoDropped !== this.previous_dropped_state
    ) {
      this.cargo_drop_marker.setIcon(DropMarker.actual_drop_icon);
      this.payload_drop_drone_marker.setLatLng(this.getDroneLatLng());
      // @ts-ignore
      this.payload_drop_drone_marker.setRotationAngle(this.telemetry.drone_pos.heading);
      this.payload_drop_drone_marker.setOpacity(0.75);
    }

    this.previous_dropped_state = this.sae_drop_data.cargoDropped;
  }

  targetUpdated() {
    return (
      this.target_circle.getLatLng().lat !== this.sae_drop_data.targetLat
      || this.target_circle.getLatLng().lng !== this.sae_drop_data.targetLng
    );
  }

  updateTimeSinceLastPacket() {
    const curr_time = Date.now();
    // @ts-ignore
    this.time_since_last_packet = curr_time - this.last_packet_time;
  }

  getDroneLatLng() {
    return new L.LatLng(
      this.telemetry.drone_pos.lat,
      this.telemetry.drone_pos.lng
    );
  }

  async loadRouteList() {
    this.route_list = await loadRoutesFromServer();
    this.show_route_list = true;
  }

  loadRouteAtIndex(index: number) {
    this.node_positions = [];
    for (const segment of this.route_list[index].route.segments) {
      this.node_positions.push(segment.end_position);
    }

    this.route_path_line.setLatLngs(this.node_positions);
    this.show_route_list = false;
  }

  updateStream() {
    if (this.show_stream) {
      this.disableStream();
    } else {
      this.enableStream();
    }
  }

  enableStream() {
    this.show_stream = true;
    this.drone_stream_img = `${BASE_DRONE_STREAM_IMG}#${this.img_index}`;
  }

  disableStream() {
    this.show_stream = false;
    this.drone_stream_img = EMPTY_STREAM_IMG;
  }
}
</script>
<style lang="sass" scoped>
#telemetryMapDiv
  height: 90vh

.sideBarContent
  height: 70%
</style>
